

# PutDefaultEncryptionConfiguration
<a name="API_PutDefaultEncryptionConfiguration"></a>

Sets the default encryption configuration for the AWS account. For more information, see [Key management](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/key-management.html) in the * AWS IoT SiteWise User Guide*.

## Request Syntax
<a name="API_PutDefaultEncryptionConfiguration_RequestSyntax"></a>

```
POST /configuration/account/encryption HTTP/1.1
Content-type: application/json

{
   "encryptionType": "string",
   "kmsKeyId": "string"
}
```

## URI Request Parameters
<a name="API_PutDefaultEncryptionConfiguration_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_PutDefaultEncryptionConfiguration_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [encryptionType](#API_PutDefaultEncryptionConfiguration_RequestSyntax) **   <a name="iotsitewise-PutDefaultEncryptionConfiguration-request-encryptionType"></a>
The type of encryption used for the encryption configuration.  
Type: String  
Valid Values: `SITEWISE_DEFAULT_ENCRYPTION | KMS_BASED_ENCRYPTION`   
Required: Yes

 ** [kmsKeyId](#API_PutDefaultEncryptionConfiguration_RequestSyntax) **   <a name="iotsitewise-PutDefaultEncryptionConfiguration-request-kmsKeyId"></a>
The Key ID of the customer managed key used for AWS KMS encryption. This is required if you use `KMS_BASED_ENCRYPTION`.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 2048.  
Required: No

## Response Syntax
<a name="API_PutDefaultEncryptionConfiguration_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "configurationStatus": { 
      "error": { 
         "code": "string",
         "message": "string"
      },
      "state": "string"
   },
   "encryptionType": "string",
   "kmsKeyArn": "string"
}
```

## Response Elements
<a name="API_PutDefaultEncryptionConfiguration_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [configurationStatus](#API_PutDefaultEncryptionConfiguration_ResponseSyntax) **   <a name="iotsitewise-PutDefaultEncryptionConfiguration-response-configurationStatus"></a>
The status of the account configuration. This contains the `ConfigurationState`. If there is an error, it also contains the `ErrorDetails`.  
Type: [ConfigurationStatus](API_ConfigurationStatus.md) object

 ** [encryptionType](#API_PutDefaultEncryptionConfiguration_ResponseSyntax) **   <a name="iotsitewise-PutDefaultEncryptionConfiguration-response-encryptionType"></a>
The type of encryption used for the encryption configuration.  
Type: String  
Valid Values: `SITEWISE_DEFAULT_ENCRYPTION | KMS_BASED_ENCRYPTION` 

 ** [kmsKeyArn](#API_PutDefaultEncryptionConfiguration_ResponseSyntax) **   <a name="iotsitewise-PutDefaultEncryptionConfiguration-response-kmsKeyArn"></a>
The Key ARN of the AWS KMS key used for AWS KMS encryption if you use `KMS_BASED_ENCRYPTION`.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1600.  
Pattern: `^arn:aws(-cn|-us-gov)?:[a-zA-Z0-9-:\/_\.]+$` 

## Errors
<a name="API_PutDefaultEncryptionConfiguration_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictingOperationException **   
Your request has conflicting operations. This can occur if you're trying to perform more than one operation on the same resource at the same time.    
 ** resourceArn **   
The ARN of the resource that conflicts with this operation.  
 ** resourceId **   
The ID of the resource that conflicts with this operation.
HTTP Status Code: 409

 ** InternalFailureException **   
 AWS IoT SiteWise can't process your request right now. Try again later.  
HTTP Status Code: 500

 ** InvalidRequestException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters. Check your request and try again.  
HTTP Status Code: 400

 ** LimitExceededException **   
You've reached the quota for a resource. For example, this can occur if you're trying to associate more than the allowed number of child assets or attempting to create more than the allowed number of properties for an asset model.  
For more information, see [Quotas](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/quotas.html) in the * AWS IoT SiteWise User Guide*.  
HTTP Status Code: 410

 ** ThrottlingException **   
Your request exceeded a rate limit. For example, you might have exceeded the number of AWS IoT SiteWise assets that can be created per second, the allowed number of messages per second, and so on.  
For more information, see [Quotas](https://docs.aws.amazon.com/iot-sitewise/latest/userguide/quotas.html) in the * AWS IoT SiteWise User Guide*.  
HTTP Status Code: 429

## See Also
<a name="API_PutDefaultEncryptionConfiguration_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotsitewise-2019-12-02/PutDefaultEncryptionConfiguration) 